function clearFiter () {
    /* Clears all filters on the page. */
    $("form.k-filter-menu button[type='reset']").trigger("click");
}
function CheckboxFilterTemplate (element, field) {
    var text = "<label style='font-weight:normal;'><input type='checkbox' name='" + element.field;
    return text + "' value='#= data." + field + " #'/> #= data." + field + " || data.all #</label><br />";
}

function CheckboxFilterTemplateUseValue(element, field) {
    var text = "<label style='font-weight:normal;'><input type='checkbox' name='" + element.field;
    return text + "' value='#= data.value #'/> #= data." + field + " || data.all #</label><br />";
}


function CheckboxFilterTemplateInt(element, field) {
    var text = "<label style='font-weight:normal;'><input type='checkbox' name='" + element.field;
    return text + "' value='#= data." + field + " #'/> #= data." + field + " #</label><br />";
}
function CheckboxFilterCycleCountTemplate(element, field) {
    var text = "<label style='font-weight:normal;'>" +
        "<input type='checkbox' name='" + element.field + "' value='#= data." + field + " #'/>" +
        "#if(#=data."+field+"){"+
        "<span class='glyphicon glyphicon-ok' style='color:\#717d44' /></span></label><br />}";
    //else {
    //    return text + "' value='#= data." + field + " #'/><span class='glyphicon glyphicon-remove' style='color:\#AD453A' /></span></label><br />";
    //}
}


function GridChangeSelected (grid, cellIndex) {
    var selected = grid.select();
    if (selected[0].cellIndex == cellIndex && selected[selected.length - 1].cellIndex == cellIndex) {
        for (var index = (selected.length > 1 ? 1 : 0) ; index < selected.length; index++) {
            var cell = selected[index];
            if (cell.cellIndex == cellIndex) {
                var item = grid.dataItem(cell.parentNode);
                item.Selected = !item.Selected;
            }
        }
    }
    grid.refresh();
}

function GridDataFiltered (dataSource) {
    var filters = dataSource.filter();
    //dataSource.read();
    var allData = dataSource.data();
    var query = new kendo.data.Query(allData);
    //query.sort()
    var array = query.filter(filters).data;
    return array;
}
function PostRequest (controller, value, callback) {
    var post = (window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP"));
    if (callback) {
        post.onreadystatechange = function () {
            if (post.readyState == 4 && post.status == 200) {
                callback(post.response);
            }
        }
    }
    post.open("POST", controller, true);
    post.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    post.send(value);
}

function ProcessGridData (dataSource, allItems, remove) {
    var data = GridDataFiltered(dataSource);
    var array = [];
    for (var index_a = data.length - 1; index_a >= 0; index_a -= 1) {
        if (allItems || data[index_a].Selected) {
            array.push(data[index_a].Value);
            if (remove) {
                dataSource.remove(data[index_a]);
            }
        }
    }
    return array;
}
function Selected (element) {
    var value = element.value;
    var parent = element.parentElement.parentElement.parentElement.parentElement.parentElement;
    if (parent.id == "") {
        parent = parent.parentElement;
    }
    var array = $(parent).data("kendoGrid");
    if (!array) {
        return;
    }
    array = array.dataSource.view();
    for (var index = 0; index < array.length; index += 1) {
        if (array[index].Value == value) {
            array[index].Selected = element.checked;
        }
    }
    TotalSelected("#" + parent.id);
}
function TotalSelected (search) {
    var dataSource = $(search).data("kendoGrid").dataSource;
    var array = GridDataFiltered(dataSource);
    var count = 0;
    for (var index = 0; index < array.length; index += 1) {
        if (array[index].Selected) {
            count += 1;
        }
    }
    var innerText = $(search + " .k-pager-info")[0];
    if (innerText) {
        innerText.innerText = "Selected Total " + count + "/" + dataSource.total();
    }
}